{Startovni cislo: 32}


program Rodokmen;
uses
  Crt, Graph;
const
  max = 500;
type

  TPohlavi = (poMuz, poZena, poNezname);
  TIDStr = string[10];     {identifikacni retezec}
  TOsoba = record          {udaje o osobach}
    id: TIDStr;
    jmeno: string[32];
    prijmeni: string[32];
    pohlavi: TPohlavi;
    narozeni: integer;
    umrti: integer;
    matka: TIDStr;
    otec: TIDStr;
  end;

  TOsoby = array [1..max] of TOsoba;
  POsoby = ^TOsoby;

var
  osoba: POsoby;              {pole osob}
  osob: longint;
  x, y, radkovani: integer;
  AktSoubor: string;  {aktualni otevreny soubor}

procedure ZapniGrafiku;
var
  Gd, Gm: integer;
begin
  Gd := Detect; InitGraph(Gd, Gm, 'egavga.bgi');
  if GraphResult <> grOk then Halt(1);
end;


procedure VypniGrafiku;
begin
  CloseGraph;
end;

procedure Zprava(s: string; cekat: boolean);   {zobrazi zpravu a prip. zapipa}
const
  mazacitext = '';
begin
  {writeln(s);}
  setcolor(0);
  OutTextXY(1, GetMaxY - 10, mazacitext);
  setcolor(15);
  OutTextXY(1, GetMaxY - 10, s);
  if cekat then
  begin
    sound(1000);    {vystrane znameni i vyzva k stisknu klavesy}
    delay(100);
    nosound;
    readkey;
  end;
end;



function StrToInt(s: string): integer;  {prevede retezec na cislo}
var
  result, c: integer;
begin
  result := 0;
  Val(s, result, c);
  if c <> 0 then Zprava('Chyba pri prevadi retezce na cislo.', true);
  StrToInt := result;
end;

function IntToStr(i: integer): string;  {prevede cislo na retezec}
var
  result: string;
begin
  Str(i, result);
  IntToStr := result;
end;

function PhlNaRetezec(p: TPohlavi): string;   {prevede pohlavi na retezec}
begin
  PhlNaRetezec := '';
  PhlNaRetezec := 'zena';
  if p = poMuz then PhlNaRetezec := 'muz';
end;

function JedinecnyID(id: TIDStr; index: integer): boolean; {otestuje, zda urcita osoba}
        {  nahodou nema konflikt s identifikatorem nektere jine osoby}
var
  result: boolean;
  i: integer;
begin
  result := true;
  for i := 1 to osob - 1 do
  begin
    if (i <> index) and (osoba^[i].id = id) then
    begin
      result := false;
      Break;
    end;
  end;
  JedinecnyID := result;
end;



function KoncovyTag(s: string): boolean;   {zda jde o koncovy tag}
begin
  KoncovyTag := false;
  if (length(s) > 0) and (s[1] = '/') then KoncovyTag := true;
end;

procedure UpStr(var s: string);        {vse na velka pismena}
var
  i: integer;
begin
  for i := 1 to length(s) do s[i] := UpCase(s[i]);  {prevede mala na velka}
end;

function ZjistiPohlavi(s: string): TPohlavi;
begin
  ZjistiPohlavi := poNezname;
  if (s <> 'M') and (s <> 'Z') then Zprava('Chyba v zadani pohlavi.', true)
  else ZjistiPohlavi := TPohlavi(s = 'Z');
end;


procedure AnalyzaDat(tag, data: string);    {ulozi data do prislusnych poli}
begin                                    {podle tagu a dat v nich}
  with osoba^[osob] do
  begin
    if tag = 'ID'       then
    begin
      id := data;
      repeat
      if not JedinecnyID(id, osob) then
      begin
        Zprava('V souboru je konflikt identifikatoru. Pokusim se ho vyresit.', true);
        id := id + '~';
      end;
      until JedinecnyID(id, osob);
    end;
    if tag = 'JMENO'    then jmeno := data;
    if tag = 'PRIJMENI' then prijmeni := data;
    if tag = 'POHLAVI'  then pohlavi := ZjistiPohlavi(data);
    if tag = 'NAROZENI' then narozeni := StrToInt(data);
    if tag = 'UMRTI'    then umrti := StrToInt(data);
    if tag = 'MATKA'    then matka := data;
    if tag = 'OTEC'     then otec := data;
  end;
end;



procedure NactiRodokmen(soubor: string);     {nacte rodokmen z xml souboru}
type
  TStav = (stNic, stTag, stData);  {stav - bud nic, nebo tag, nebo data}
var                                  {"poloha v souboru"}
  f: text;
  s: string;
  tag, data: string;
  ch: char;
  stav: TStav;
  koncovy: boolean;

begin
  assign(f, soubor);
  {$I-}
  reset(f);                         {otevre soubor}
  {$I+}
  if IOResult <> 0 then
  begin
    Zprava('Soubor nebyl nalezen.', true);
    exit;
  end;
  AktSoubor := soubor;               {zapamatuje si nazev, pripadne je pouzit pri ukladani}
  while not eof(f) do  {dokud nenacte cely soubor}
  begin
    tag := '';
    data := '';
    stav := stNic;
    while not eoln(f) do {dokud nedocte radku}
    begin
      read(f, ch);      {nacte znak}
      if (stav = stNic) and (ch = ' ') then Continue;  {preskakuje nevyznamne mezery}

      if (stav = stNic) and (ch = '<') then
      begin
        stav := stTag; {prechod do rezimu tag}
        tag := '';
      end;
      if (stav = stTag) and (ch = '>') then
      begin
        UpStr(tag);                         {analyza tagu a dat v nem}
        if (length(tag) > 0) and (tag[length(tag)] = '/') then
        begin
          stav := stNic;
          tag := '';
          Continue;
        end;

        koncovy := KoncovyTag(tag);
        if koncovy then
        begin
          tag := copy(tag, 2, length(tag) - 1);   {odstrani lomitko}
          AnalyzaDat(tag, data);    {ulozi data}
          data := '';
        end;
        if tag = 'OSOBA' then
        begin
          if not koncovy then
          begin
            if osob >= max then
            begin
              Zprava('Prilis mnoho osob.', true);
              close(f);
              exit;
            end;
            inc(osob);                {vznika nova osoba}
            with osoba^[osob] do
            begin
              id := '';
              jmeno := '';
              prijmeni := '';
              pohlavi := poNezname;
              narozeni := 0;
              umrti := 0;
              matka := '';
              otec := '';
            end
          end
          else
          begin
            if osoba^[osob].ID = '' then Zprava('Osobe chybi identifikator.', true);
          end;
        end;

        if koncovy then stav := stNic else stav := stData; {prechod do rezimu data}
        if (tag = 'RODOKMEN') or (tag = 'OSOBA') then stav := stNic;

        tag := '';
        Continue;  {skok dal}
      end;
      if (stav = stData) and (ch = '<') then
      begin
        stav := stTag; {prechod do rezimu tag}
      end;

      if stav = stTag then
      begin
        if (ch <> '<') and (ch <> '>') then tag := tag + ch;
      end;                                      {sbira znaky do tagu}

      if stav = stData then
      begin
        data := data + ch;              {sbira znaky do dat}
      end;
    end;
    if not eof(f) then readln(f);         {odradkuje}
  end;
  close(f);

end;

function VratMezery(n: integer): string;    {pouziva se pri ukladani}
var
  i: integer;
  result: string;
begin
  result := '';
  for i := 1 to n do
  begin
    result := result + ' ';
  end;
  VratMezery := result;
end;


procedure UlozRodokmen(soubor: string);    {ulozi rodokmen}
var
  f: text;
  s: string;
  i: integer;
begin
  assign(f, soubor);
  {$I-}
  rewrite(f);
  {$I+}
  if IOResult <> 0 then
  begin
    Zprava('Soubor nelze ulozit.', true);
    exit;
  end;
  writeln(f, '<rodokmen>');
  for i := 1 to osob do
  with osoba^[i] do
  begin
    writeln(f, VratMezery(3) + '<osoba>');

    writeln(f, VratMezery(6) + '<id>' + id + '</id>');


    {voli mezi "<tag/>" a "<tag>neco</tag>"}
    if jmeno <> '' then
      writeln(f, VratMezery(6) + '<jmeno>' + jmeno + '</jmeno>')
    else writeln(f, VratMezery(6) + '<jmeno/>');


    if prijmeni <> '' then
      writeln(f, VratMezery(6) + '<prijmeni>' + prijmeni + '</prijmeni>')
    else writeln(f, VratMezery(6) + '<prijmeni/>');

    s := PhlNaRetezec(pohlavi);
    if pohlavi <> poNezname then
      writeln(f, VratMezery(6) + '<pohlavi>' + UpCase(s[1]) + '</pohlavi>')
    else writeln(f, VratMezery(6) + '<pohlavi/>');

    if narozeni <> 0 then
      writeln(f, VratMezery(6) + '<narozeni>', narozeni, '</narozeni>')
    else writeln(f, VratMezery(6) + '<narozeni/>');

    if umrti <> 0 then
      writeln(f, VratMezery(6) + '<umrti>', umrti, '</umrti>')
    else writeln(f, VratMezery(6) + '<umrti/>');

    if matka <> '' then
      writeln(f, VratMezery(6) + '<matka>' + matka + '</matka>')
    else writeln(f, VratMezery(6) + '<matka/>');

    if otec <> '' then
      writeln(f, VratMezery(6) + '<otec>' + otec + '</otec>')
    else writeln(f, VratMezery(6) + '<otec/>');

    writeln(f, VratMezery(3) + '</osoba>');
  end;
  writeln(f, '</rodokmen>');
  close(f);
end;




procedure MujOutTextLn(s: string);    {jako writeln}
begin
  OutTextXY(x, y, s);
  x := 0;
  inc(y, radkovani);
end;

procedure NastavVelikostPisma(velikost: integer);
begin
  SetTextStyle(DefaultFont, HorizDir, velikost);
end;

procedure NastavPolohuKurzoru(mx, my: integer);
begin
  x := mx;
  y := my;
end;


procedure HlavniMenu;
begin
  radkovani := 15;
  ClearDevice;

  NastavPolohuKurzoru(75, 0);
  NastavVelikostPisma(5);
  setcolor(12);
  MujOutTextLn('Hlavni menu');

  NastavPolohuKurzoru(0, 100);
  setcolor(10);
  NastavVelikostPisma(1);
  MujOutTextLn('1. Prochazeni seznamu vsech osob + pridavani, ruseni, upravovani.');
  MujOutTextLn('2. Zobrazeni stromu');
  MujOutTextLn('');
  MujOutTextLn('<F2> Ulozeni rodokmenu  <F3> Otevreni rodokmenu  <F4> Slouceni s jinym rodokmenem  <ESC> Konec');
end;

procedure ZobrazZahlavi(y: integer);       {zobrazi hlavicku tabulky pri prochazeni vsech osob}
begin
  setcolor(15);
  OutTextXY(0, y, 'ID');
  OutTextXY(30, y, 'Jmeno');
  OutTextXY(150, y, 'Prijmeni');
  OutTextXY(300, y, 'Phl.');
  OutTextXY(340, y, 'Naroz.');
  OutTextXY(400, y, 'Umrti');
  OutTextXY(450, y, 'Matka');
  OutTextXY(550, y, 'Otec');
end;

procedure ZobrazDataOsoby(index, y: integer);    {zobrazuje inf. o jednotl. osobach}
begin
  if osob < 1 then exit;
  if y > 130 then setcolor(12) else setcolor(15);
  with osoba^[index] do
  begin
    OutTextXY(0, y, id);
    if jmeno <> '' then OutTextXY(30, y, jmeno);
    if prijmeni <> '' then OutTextXY(150, y, prijmeni);
    if pohlavi <> poNezname then OutTextXY(300, y, PhlNaRetezec(pohlavi));
    if narozeni <> 0 then OutTextXY(340, y, IntToStr(narozeni));
    if umrti <> 0 then OutTextXY(400, y, IntToStr(umrti));
    if matka <> '' then OutTextXY(450, y, matka);
    if otec <> '' then OutTextXY(550, y, otec);
  end;
end;

procedure OznacVybranouPolozku(vybrane, y: integer); {cervena carecka jako kurzor pro editaci}
begin
  setcolor(12);
  case vybrane of
    1: Line(0, y + 10, 0 + 20, y + 10);
    2: Line(30, y + 10, 30 + 20, y + 10);
    3: Line(150, y + 10, 150 + 20, y + 10);
    4: Line(300, y + 10, 300 + 20, y + 10);
    5: Line(340, y + 10, 340 + 20, y + 10);
    6: Line(400, y + 10, 400 + 20, y + 10);
    7: Line(450, y + 10, 450 + 20, y + 10);
    8: Line(550, y + 10, 550 + 20, y + 10);
  end;
end;

procedure PrijmiUdaj(index, vybrane: integer);  {vstup z klavesnice pri editaci}
var
  s: string;
begin
  Zprava('Zadejte tento udaj (u pohlavi bud "M", nebo "Z").', false);
  with osoba^[index] do
    case vybrane of
      1:
      begin
        repeat
          readln(id);
          if JedinecnyID(id, index) = false then
          begin
            Zprava('Tento identifikator je jiz obsazeny. Zkuste to znovu.', true);
            id := '';
          end;
        until id <> '';
      end;
      2: readln(jmeno);
      3: readln(prijmeni);
      4: begin readln(s); pohlavi := ZjistiPohlavi(s); end;
      5: begin readln(s); narozeni := StrToInt(s) end;
      6: begin readln(s); umrti := StrToInt(s) end;
    end;
end;


procedure Menu1;         {Menu prochazeni osob}
begin
  radkovani := 15;
  ClearDevice;

  NastavPolohuKurzoru(75, 0);
  NastavVelikostPisma(4);
  setcolor(14);
  MujOutTextLn('Prochazeni osob');

  NastavPolohuKurzoru(0, 450);
  setcolor(10);
  NastavVelikostPisma(1);
  MujOutTextLn('<Sipky> Pohyb  <ENTER> Editace <INS> Pridani <DEL> Smazani <ESC> Zpet');
end;


procedure ProchazeniOsob;
const
  plny : FillPatternType = ($FF, $FF, $FF,
    $FF, $FF, $FF, $FF, $FF);

var
  zn: char;
  poz, poz2: integer;   {pozice prochazenych osob}
  rezim2: boolean;   {zda prochazi osoby 2x (napr. pri vyhledavani matky)}
  vybrane: integer;  {co je vybrane k editaci}
  i: integer;
begin
  Menu1;
  Zprava('S pomoci cervene carky muzete vybirat data k editaci (sipka doleva a doprava).', false);
  poz := 1;
  poz2 := 1;
  rezim2 := false;
  vybrane := 1;
  ZobrazZahlavi(100);
  ZobrazDataOsoby(poz, 130);
  if rezim2 then ZobrazDataOsoby(poz2, 150);
  OznacVybranouPolozku(vybrane, 130);
  repeat
    zn := readkey;
    if (zn = #13) and (osob > 0) then
    begin
      if not rezim2 then
      begin
        if vybrane < 7 then
        begin
          PrijmiUdaj(poz, vybrane);     {zadani z klavesnice}
          Menu1;
          ZobrazZahlavi(100);
          ZobrazDataOsoby(poz, 130);
          if rezim2 then ZobrazDataOsoby(poz2, 150);
          OznacVybranouPolozku(vybrane, 130);
        end
        else
        begin
          rezim2 := true;                {vybere se z cerveneho seznamu}
          Zprava('Vyberte prislusnou osobu z cerveneho seznamu.', false);
          ZobrazDataOsoby(poz2, 150);
        end;
      end
      else
      begin
        if vybrane = 7 then
        begin                                            {kontrola}
          if osoba^[poz].id <> osoba^[poz2].id then osoba^[poz].matka := osoba^[poz2].id
          else Zprava('Osoba sama sobe nemuze byt matkou.', true);
        end;
        if vybrane = 8 then
        begin
          if osoba^[poz].id <> osoba^[poz2].id then osoba^[poz].otec := osoba^[poz2].id
          else Zprava('Osoba sama sobe nemuze byt otcem.', true);
        end;
        if osoba^[poz].matka = osoba^[poz].otec then Zprava('Varovani, osoba ma stejneho otce i matku.', true);

        rezim2 := false;
        Menu1;
        ZobrazZahlavi(100);
        ZobrazDataOsoby(poz, 130);
        if rezim2 then ZobrazDataOsoby(poz2, 150);
        OznacVybranouPolozku(vybrane, 130);
      end;
    end;
    if zn = #0 then
    begin
      zn := readkey;
      if rezim2 then
      begin
        if zn = 'H' then dec(poz2);         {pohyb}
        if zn = 'P' then inc(poz2);
        if poz2 < 1 then poz2 := 1;
        if poz2 > osob then poz2 := osob;
      end
      else
      begin
        if zn = 'H' then dec(poz);
        if zn = 'P' then inc(poz);
        if zn = 'K' then dec(vybrane);
        if zn = 'M' then inc(vybrane);
        if poz < 1 then poz := 1;
        if poz > osob then poz := osob;
        if vybrane < 1 then vybrane := 1;
        if vybrane > 8 then vybrane := 8;
      end;

      if zn = #82 then    {INS}
      begin
        if osob >= max then Zprava('Prilis mnoho osob.', true)
        else
        begin
          inc(osob);
          with osoba^[osob] do
          begin
            id := '';
            jmeno := '';
            prijmeni := '';
            pohlavi := poNezname;
            narozeni := 0;
            umrti := 0;
            matka := '';
            otec := '';
          end;
          SetFillPattern(plny, Black);
          bar(0, 100, GetMaxX - 1, 400);
          setcolor(15);
          ZobrazZahlavi(100);

          Zprava('Zadejte identifikator osoby.', false);
          repeat
            readln(osoba^[osob].id);
            poz := osob;
            if JedinecnyID(osoba^[osob].id, osob) = false then
            begin
              Zprava('Tento identifikator je jiz obsazeny. Zkuste to znovu.', true);
              osoba^[osob].id := '';
            end;
          until osoba^[osob].id <> '';

          Menu1;
          ZobrazZahlavi(100);
          ZobrazDataOsoby(poz, 130);
          if rezim2 then ZobrazDataOsoby(poz2, 150);
          OznacVybranouPolozku(vybrane, 130);
          Zprava('Ostatni data jsou libovolna, muzete je doplnit editaci.', false);
        end;
      end;

      if (zn = #83) and (osob > 0) then       {DEL}
      begin
        for i := poz to osob - 1 do
          osoba^[i] := osoba^[i + 1];
        dec(osob);
      end;

      SetFillPattern(plny, Black);
      bar(0, 100, GetMaxX - 1, 400);
      setcolor(15);
      ZobrazZahlavi(100);
      ZobrazDataOsoby(poz, 130);
      if rezim2 then ZobrazDataOsoby(poz2, 150);
      OznacVybranouPolozku(vybrane, 130);
    end;
  until zn = #27;
end;



var
  soubor: string;
  zn: char;

begin
  new(osoba);
  osob := 0;
  ClrScr;
  {NactiRodokmen('simpsons.xml');}
  ZapniGrafiku;
  repeat
    HlavniMenu;
    zn := readkey;
    if zn = '1' then ProchazeniOsob;
    if zn = #0 then
    begin
      zn := readkey;
      if zn = #61 then  {F3}
      begin
        Zprava('Zadejte jmeno souboru, ktery chcete otevrit.', false);
        readln(soubor);
        osob := 0;
        NactiRodokmen(soubor);
      end;
      if zn = #60 then  {F2}
      begin
        Zprava('Zadejte jmeno souboru, kam chcete ukladat (zadejte nic pro aktualne otevreny).'
        , false);
        readln(soubor);
        if soubor = '' then soubor := AktSoubor;
        UlozRodokmen(soubor);
      end;
      if zn = #62 then  {F4}
      begin
        Zprava('Zadejte jmeno souboru, s kterym chcete sloucit aktualni rodokmen.', false);
        readln(soubor);
        NactiRodokmen(soubor);
      end;
    end;
  until zn = #27;  {ESC}
  VypniGrafiku;
  dispose(osoba);
end.
